/**************************************************************
	LCD test with using printf format
	SC1602BS 16 columns 2 lines (Default)
	 for PIC16F1823
 **************************************************************
	author air_variable
	http://www.ne.jp/asahi/air/variable/
	Tools:
	MPLAB IDE v8.85
	MPLAB XC8 compiler ver. 1.0 (Hitech PICC v9.83)
---------------------------------------------------------------
Date	:Time	Version	Build	Note
---------------------------------------------------------------
Date	:Time	Version	Build	Note
20120704:0020	0.01	---		begin the program
---------------------------------------------------------------
	Pin assignment
	1:VDD:P:2.7V TO 5V
	2:RA5:I:RIGHT SW
	3:RA4:I:LEFT SW
	4:RA3/MCLR:I:MODE SW/PICKIT2-1(W/10kPU)
	5:RC5:O:P PULSE OUT(IF YOU NEED)
	6:RC4:0:TX(NOT USED)
	7:RC3:O:LCD D7

	14:VSS:Power GND
	13:RA0:O:LCD E
	12:RA1:I:RX
	11:RA2:O:LCD RS
	10:RC0:O:LCD D4
   	 9:RC1:0:LCD D5
	 8:RC2:O:LCD D6
---------------------------------------------------------------

**************************************************************/
#include <htc.h>
//#include <xc.h>
#include <stdio.h>
#include "lcd.h"

#define MHz 000000
#define _XTAL_FREQ 8MHz

//__CONFIG
__CONFIG(
	FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_OFF 
	& CP_OFF & CPD_OFF & BOREN_ON & CLKOUTEN_OFF 
	& IESO_OFF & FCMEN_OFF
	);

__CONFIG(
	WRT_OFF & PLLEN_OFF & STVREN_ON & LVP_OFF
	& BORV_LO	//more and equal HItechPICC ver 9.83
	);

//Global settings (none)



void interrupt handler( void ){	//interrupt handle
	//timer interval
	TMR0IF =0 ;
}


void delay_10ms(unsigned int temp){	//10ms multiple x times
	while(temp--){
		__delay_ms(10);
	}	
}

//Write one character (correspond printf) 
void putch(unsigned char c){
	lcd_putch(c);
	return;
}


//------------------main
main()
{
// Register
	unsigned char temp,data;
	unsigned int data16 =0;
//	Port initalize
//		  	  76543210
	PORTA = 0b11100000;	//Port Initalize
	PORTC = 0b00000000;	//Port Initalize
	TRISA = 0b11111010; //
	TRISC = 0b11010000; //ccp1 output
	ANSELA	= 0x00;		//All port are use for digital port
	ANSELC	= 0x00;		//All port are use for digital port
	CM1CON0 = 0x07;		//PORTA is all digital I/O
	RXDTSEL	= 1;		//RA0 pin assignment as RXD
	OSCCON	= 0b01110010;	// PLL off,8MHz,IntOSC

//Init
	OPTION_REG = 0b00000111; // prescale 1/256 RBPU= EN
	GIE  = 0;//Int off

//timer0 setting (interrupt event timer 3.328ms)
	TMR0IE = 0;//timer interrupt is off
	TMR0 = 0;//interrupt timer counter set

//PWM initialize setting (83.8KHz on RB3 @8MHz)
	CCP1CON	=	0b00001100;	//Single output,LSBset,PWM mode: P1A, P1C active-high; P1B, P1D active-high
	PR2 = 0x17; // resolution is 6.5bit mode
	CCPR1L = 0x0c; // duty is 50%
	T2CON = 0b00000100;	// POSTSCALE 1:1 ,TMR2 ON , PRESCALE 1:1


//LCD init
	delay_10ms(20);//stabilize time
	lcd_init();		//lcd initalize
	lcd_clear();	//lcd clear
	lcd_write(LCD_CursorOff);

//LCD display (Loop forever)
	while(1){
		lcd_goto(LCD_LineNumber1);
		printf("Count(10): %05d",data16); 	// display as decimal
		lcd_goto(LCD_LineNumber2);
		printf("Count(16):  %04X",data16);	//display as hexadecimal
		data16++;
		delay_10ms(50);//0.5s wait
	}
}
